﻿using System;
using System.Collections.Generic;

namespace DesktopTools.Models
{
	/// <summary>
	/// Настройки для таблицы вывода списка записей сущности
	/// </summary>
	public class ControlViewEntityListConfiguration
	{
		/// <summary>
		/// Тип класса, который будет выводится
		/// </summary>
		public Type EntityType { get; set; }

		/// <summary>
		/// Список названий кнопок, которые надо скрыть
		/// </summary>
		public List<string> ShowToolStripButton { get; set; }

		/// <summary>
		/// Перечень действий для контектснго меню и выпадающего в верхнем меню пункта "Действия"
		/// </summary>
		public Dictionary<string, (string Title, EventHandler Event)> ControlOnMoveElem { get; set; } = null;

		/// <summary>
		/// Есть пагинация
		/// </summary>
		public bool PaginationOn { get; set; } = true;

		/// <summary>
		/// Перечень значений для выбора при выводе пагинации по названиям
		/// </summary>
		public List<string> PageNamesForPagination { get; set; } = null;

		/// <summary>
		/// Количество записей на странице (для пагинации)
		/// </summary>
		public int? CountElementsOnPage { get; set; } = null;
	}
}