﻿using ModelTools.Models;

namespace ModelTools.Interfaces
{
	public interface ISecurityManager
	{
		/// <summary>
		/// Сообщение с причиной не получения доступа
		/// </summary>
		string ErrorMessage { get; set; }

		/// <summary>
		/// Авторизация пользователя к операции
		/// </summary>
		/// <param name="model">Данные по операции</param>
		/// <returns></returns>
		bool CheckAccess(SecurityManagerCheckAccessModel model);

		/// <summary>
		/// Проверка наличия старотвых данных для работы с ситемой
		/// </summary>
		void CheckStartDataSource();
	}
}