﻿using ModelTools.BindingModels;
using ModelTools.Enums;
using System;
using System.ComponentModel.DataAnnotations;

namespace SecurityBusinessLogic.BindingModels
{
	/// <summary>
	/// Получение информации по доступу
	/// </summary>
	public class AccessGetBindingModel : GetBindingModel
	{
		public Guid? RoleId { get; set; }

		/// <summary>
		/// Для вывода списка доступов по роли в контроле десктопном
		/// </summary>
		public string RoleName { get; set; }
	}

	/// <summary>
	/// Сохранение информации по доступу
	/// </summary>
	public class AccessSetBindingModel : SetBindingModel
	{
		public Guid RoleId { get; set; }

		[Required(ErrorMessage = "required")]
		public AccessOperation Operation { get; set; }

		public AccessType AccessType { get; set; }
	}
}