﻿using ModelTools.BusinessLogics;
using ModelTools.Enums;
using ModelTools.Models;
using SecurityBusinessLogic.BindingModels;
using SecurityBusinessLogic.Interfaces;
using SecurityBusinessLogic.ViewModels;

namespace SecurityBusinessLogic.BusinessLogics
{
	/// <summary>
	/// Логика работы с пользователями
	/// </summary>
	public class UserBusinessLogic : BusinessLogicCore<UserGetBindingModel, UserSetBindingModel, UserListViewModel, UserViewModel>
	{
		public UserBusinessLogic(IUserService service) : base(service, "Пользователи", AccessOperation.Пользователи) { }

		protected override UserViewModel ConvertToE(OperationResultModel model) => model.Result as UserViewModel;

		protected override UserListViewModel ConvertToL(OperationResultModel model) => model.Result as UserListViewModel;
	}
}